package alco.com;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Date;


import alco.com.ImageAdapter;
import alco.com.R;
import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.DialogInterface.OnDismissListener;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Typeface;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ImageView.ScaleType;


/**
 * This adapter prepares the view used in DataGrid cells.
 */
class ImageAdapter extends BaseAdapter {
    private Context mContext;
    private Handler button_enable_handler = new Handler();
    

    public ImageAdapter(Context c) {
        mContext = c;
    }

    public int getCount() {
    	int temp;
    	try
    	{
	    	Log.i("Alcometer", "Query2");
	    	String[] columns = {"NULL"};
	    	Cursor cur = Alcometer.db.query("Drinks", columns, null, null, null, null, null);
	    	temp = cur.getCount();
	    	Log.i("Alcometer", "Query2 done rows:" + temp);
    	}
    	catch(Exception ex)
    	{
    		Log.e("Alcometer", ex.getMessage());
    		return 0;
    	}
    	return temp;
    }

    public Object getItem(int position) {
        return null;
    }

    OnClickListener listener = new OnClickListener() {
    	
		@Override
		public void onClick(View v1) {
			View v = (View) v1.getParent();
			int id = v.getId();
			String[] args = { ""+id };
			
			//Fetch the data from the database based on the button clicked
			Cursor cur = Alcometer.db.rawQuery("SELECT precentage, volume, drink, picture_id FROM 'Drinks' WHERE id = ?", args);
			if(cur.moveToNext()){
				String[] args2 = { cur.getString(2), cur.getString(0), cur.getString(1), cur.getString(3) };
				Alcometer.db.execSQL("INSERT INTO 'DrinkLog' (drink, precentage, volume, picture_id) VALUES(?, ?, ?, ?)", args2);
				Alcometer.calculateNewPrec(cur.getDouble(0), cur.getDouble(1));
				v1.setEnabled(false);
				if (view_to_enable != null)
				{
					view_to_enable.setEnabled(true);
					button_enable_handler.removeCallbacks(taskEnableButtons);
				}
				view_to_enable = v1;
				button_enable_handler.postDelayed(taskEnableButtons, 1000); //Disable the button for a second to prevent doubleclicks
			} else{
				Log.e("Alcometer", "Could not fetch drink data");
			}
		}
	};

	private View view_to_enable = null;
    private Runnable taskEnableButtons = new Runnable() {
		@Override
		public void run() {
			if (view_to_enable != null)
			{
				view_to_enable.setEnabled(true);
				view_to_enable = null;
			}
			
		}
	};

	public long getItemId(int position) {
        return 0;
    }

    // create a new View for each item referenced by the Adapter
    public View getView(int position, View convertView, ViewGroup parent) {
        ImageButton button;
        TextView upperText;
        TextView lowerText;
        View v;
        
        if (convertView == null) {  
        	
            LayoutInflater li = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            v = li.inflate(R.layout.button, null);
            button = (ImageButton) v.findViewById(R.id.button);
            button.setOnClickListener(listener);
        } else {
        	v = (View)convertView;
            button = (ImageButton) v.findViewById(R.id.button);
        }
        upperText = (TextView) v.findViewById(R.id.upper_text);
        lowerText = (TextView) v.findViewById(R.id.bottom_text);

        String[] args = { ""+position };
        
        Cursor cur = Alcometer.db.rawQuery("SELECT id, drink, precentage, volume, picture_id FROM 'Drinks' ORDER BY id ASC LIMIT ?,1", args);

       Integer[] picture_ids = Alcometer.picture_ids;
        if (cur.getCount() == 0)
        {
        	v.setId(-1);
        	button.setEnabled(false);
            button.setVisibility(View.GONE);
            upperText.setText("");
            lowerText.setText("");
        }
        else
        {
	        try
	        {
	        	cur.moveToNext();
	            Log.i("Alcometer", "Query1 done");
	            Log.i("Alcometer", "Query1 result:" + cur.getString(1));
	            button.setEnabled(true);
	            v.setId(cur.getInt(0));
	            button.setImageResource(picture_ids[cur.getInt(4)%picture_ids.length]);
	            upperText.setText(cur.getString(1));
	            lowerText.setText(cur.getString(3)+"L|"+cur.getString(2)+"%");
	            Log.i("Alcometer", "Query1 fecthed");
	        }
	        catch(Exception ex)
	        {
	            Log.e("Alcometer", ex.getMessage());
	        }
        }
          return v;
    }

}


public class Alcometer extends Activity {

	public class Person
	{
		public double coefficent;
		public double weight;
		public boolean isMan = true;
		
		public void savePersonalInfo(){
		      SharedPreferences settings = getSharedPreferences("Prefs", 0);
		      SharedPreferences.Editor editor = settings.edit();
		      editor.putBoolean("Gender", isMan);
		      editor.putFloat("Weight", (float)weight);
		      // Don't forget to commit your edits!!!
		      editor.commit();
		}
		
		public void getPersonalInfo(){
			SharedPreferences settings = getSharedPreferences("Prefs", 0);
			isMan = settings.getBoolean("Gender", true);
			weight = settings.getFloat("Weight", 100.0f);
			if(isMan)
				coefficent = 0.75;
			else
				coefficent = 0.66;
		}
	};
	
	public static SQLiteDatabase db;
	public static TextView output_text;
	public static TextView output_time;
	public static ImageView output_image;
	public static double current_grams_of_alcohol = 0.000;
	public static Date last_update_time = new Date();
	public static Person person;
	public static Context context;
	public static Alcometer instance;
	private ImageAdapter imageAdapter = null;
    private Handler handler = new Handler();
    // references to our images

    public static Integer[] picture_ids = {
            R.drawable.beer, R.drawable.coke,
            R.drawable.booze, R.drawable.wine,
            R.drawable.shot, R.drawable.whiskey,
            R.drawable.rum, R.drawable.longdrink,
            R.drawable.cider
    };

	

    @Override
    protected void onSaveInstanceState(Bundle outState) {
    	// TODO Auto-generated method stub
    	super.onSaveInstanceState(outState);
    	outState.putDouble("grams_of_alcohol", current_grams_of_alcohol);
    	outState.putLong("lastUpdate", last_update_time.getTime());
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
    	// TODO Auto-generated method stub
    	super.onRestoreInstanceState(savedInstanceState);
    	current_grams_of_alcohol = savedInstanceState.getDouble("grams_of_alcohol");
    	last_update_time = new Date(savedInstanceState.getLong("lastUpdate"));
    }
    
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        person = new Person();
        person.getPersonalInfo();
        instance = this;
        context = this;
        
        try{
        	Log.i("Alcometer", "opening the database.");
        	db = this.openOrCreateDatabase("database", MODE_PRIVATE, null);
        	//Create the table to the database if it doesn't exist
            db.execSQL(
            		"CREATE TABLE IF NOT EXISTS 'Drinks' (" +
            		"id INTEGER PRIMARY KEY AUTOINCREMENT," +
            		"drink VARCHAR(32)," +
            		"precentage DECIMAL(2,1)," +
            		"volume DECIMAL(2,1)," +
            		"picture_id INTEGER" +
            		")");
            db.execSQL(
            		"CREATE TABLE IF NOT EXISTS 'DrinkLog' (" +
            		"id INTEGER PRIMARY KEY AUTOINCREMENT," +
            		"drink VARCHAR(32)," +
            		"precentage DECIMAL(2,1)," +
            		"volume DECIMAL(2,1)," +
            		"picture_id INTEGER" +
            		")");
            
        	updateBAC();
        	Log.i("Alcometer", "plaaplaa" + current_grams_of_alcohol);
        	if (current_grams_of_alcohol == 0.00)
        	{
            	Log.i("Alcometer", "plaaplaa2 ");
        		Alcometer.db.execSQL("DELETE FROM 'DrinkLog'");
        	}
            
        } catch(SQLException ex){
        	Log.e("Alcometer", ex.getMessage());
        }

        if(db == null || !db.isOpen())
        	finish();
        
        //Done with the db stuff. Prepare the layout
        setContentView(R.layout.main);
        GridView gridview = (GridView) findViewById(R.id.DrinkList);
        imageAdapter = new ImageAdapter(this);
        gridview.setAdapter(imageAdapter);
        
        ImageView imgv = (ImageView) findViewById(R.id.output_image);
        imgv.setScaleType(ScaleType.CENTER_CROP);
        imgv.setAdjustViewBounds(true);
        imgv.setMaxHeight(100);
        imgv.setMaxWidth(100);
        imgv.setImageResource(R.drawable.teekkari0);
        output_image = imgv;
        
        TextView textv = (TextView) findViewById(R.id.output_text);
        textv.setText("0.000%");
        textv.setTypeface(Typeface.DEFAULT_BOLD);
        textv.setTextSize(40);
        output_text = textv;

        output_time = (TextView) findViewById(R.id.output_time);
        output_time.setText("00:00");
        
        
        taskUpdateBAC.run();
    }
    
    //Updates the current BAC% based on the current amount of alcohol.
    public static void updateBAC()
    {
    	Date now = new Date();
    	long diff = now.getTime() - last_update_time.getTime();
    	double hours = diff/(1000.0*60.0*60.0);
    	last_update_time = now;
//    	double grams_burned = hours * 0.1 * person.weight;
    	double grams_burned = hours * 0.1 * person.weight * 200;

    	double old_grams = current_grams_of_alcohol;

    	current_grams_of_alcohol -= grams_burned;
    	if (current_grams_of_alcohol < 0.0)
    		current_grams_of_alcohol = 0.0;

    	double oldBAC = old_grams/(person.weight*person.coefficent)/10.0;
    	double newBAC = current_grams_of_alcohol/(person.weight*person.coefficent)/10.0;

    	if (oldBAC > 0.05 && newBAC < 0.05)
    	{
	    	Notification not = new Notification(android.R.drawable.star_on,
	    			"You can drive!", System.currentTimeMillis());
	    	not.flags = Notification.FLAG_AUTO_CANCEL;
	    	Intent intent = instance.getIntent();
	    	PendingIntent pIndent = PendingIntent.getActivity(instance.getApplicationContext(), 0, intent, 0);
	    	not.setLatestEventInfo(instance.getApplicationContext(), "You can drive now!", "You may not still be fit to drive in reality. Watch out!", pIndent);
	    	
	    	NotificationManager nm = (NotificationManager)context.getSystemService(NOTIFICATION_SERVICE);
	    	nm.notify(0, not);
    	}
    }
    
    //Sets the view according to the BAC
    public static void updateBACView()
    {
    	double BAC = current_grams_of_alcohol/(person.weight*person.coefficent)/10.0;
    	
    	if (BAC < 0.05)
    	{
    		output_image.setImageResource(R.drawable.teekkari0);
    	}
    	else if (BAC < 0.1)
    	{
    		output_image.setImageResource(R.drawable.teekkari1);
    	}
    	else if (BAC < 0.15)
    	{
    		output_image.setImageResource(R.drawable.teekkari2);
    	}
    	else if (BAC < 0.3)
    	{
    		output_image.setImageResource(R.drawable.teekkari3);
    	}
    	else
    	{
    		output_image.setImageResource(R.drawable.teekkari4);
    	}

    	NumberFormat fmt = new DecimalFormat("0.0''");
    	output_text.setText(fmt.format(BAC*10.0));
    	double time_left = current_grams_of_alcohol/(0.1*person.weight);
    	int hours = (int)Math.floor(time_left);
    	int minutes = (int)Math.floor((time_left - (double)hours)*60.0);

    	fmt = new DecimalFormat("00");
    	output_time.setText("Time until sober: "+fmt.format(hours)+":"+fmt.format(minutes)+"h");
    }
    
    //A timer to update the view
    private Runnable taskUpdateBAC = new Runnable() {
		
		@Override
		public void run() {
			updateBAC();
			updateBACView();
			handler.postDelayed(this, 1000*5);
//			handler.postDelayed(this, 1000*60*10);
		}
	};
    public static void calculateNewPrec(double precentage, double volume){
    	final double alcohol_density = 7.894;
    	double grams_of_alcohol = precentage * volume * alcohol_density;
    	
    	double old_grams = current_grams_of_alcohol;
    	current_grams_of_alcohol += grams_of_alcohol;
    	double oldBAC = old_grams/(person.weight*person.coefficent)/10.0;
    	double newBAC = current_grams_of_alcohol/(person.weight*person.coefficent)/10.0;

    	if (oldBAC < 0.6 && newBAC > 0.6)
    	{
    		Toast t = Toast.makeText(context, "Codecamp spirit!", 1000);
    		t.show();
    	}

    	else if (oldBAC < 0.3 && newBAC > 0.3)
    	{
    		Toast t = Toast.makeText(context, "Call an ambulance!", 1000);
    		t.show();
    	}
    	
    	else if (oldBAC < 0.2 && newBAC > 0.2)
    	{
    		Toast t = Toast.makeText(context, "Seriously. STOP!", 1000);
    		t.show();
    	}

    	else if (oldBAC < 0.15 && newBAC > 0.15)
    	{
    		Toast t = Toast.makeText(context, "Maybe you should slow down!", 1000);
    		t.show();
    	}

    	else if (oldBAC < 0.1 && newBAC > 0.1)
    	{
    		Toast t = Toast.makeText(context, "Have fun, but watch out!", 1000);
    		t.show();
    	}

    	else if (oldBAC < 0.05 && newBAC > 0.05)
    	{
    		Toast t = Toast.makeText(context, "Don't drink and drive!", 1000);
    		t.show();
    	}

    	updateBACView();    	
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	menu.add("Manage drinks");
    	menu.add("Drink Log");
    	menu.add("Settings");
    	menu.add("Exit");
    	
    	
    	return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	CharSequence title = item.getTitle();
    	if(title.equals("Exit")){
    		finish();
    	}
    	else if (title.equals("Settings"))
    	{
    		SettingsDialog sd = new SettingsDialog(this);
    		sd.setOnDismissListener(new OnDismissListener() {
				
				@Override
				public void onDismiss(DialogInterface dialog) {
					updateBACView();
				}
			});
    		sd.show();
    	} else if(title.equals("Manage drinks")){
    		DrinkDialog dd = new DrinkDialog(this);
    		dd.setOnDismissListener(new OnDismissListener() {
				
				@Override
				public void onDismiss(DialogInterface dialog) {
					imageAdapter.notifyDataSetChanged();
				}
			});
    		dd.show();
    	} else if(title.equals("Drink Log")){
    		DrinkLog dd = new DrinkLog(this);
    		dd.setOnDismissListener(new OnDismissListener() {

				@Override
				public void onDismiss(DialogInterface dialog) {
					updateBACView();
				}
			});
    		dd.show();
    	}
    	
    	return super.onOptionsItemSelected(item);
    }
}