package alco.com;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.database.Cursor;
import android.graphics.Color;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.ImageView.ScaleType;

public class DrinkDialog extends Dialog {

	private TableRow current_selection = null;
	View.OnClickListener rowListener = new View.OnClickListener() {
		private TableRow last_selected = null;
		

		@Override
		public void onClick(View v) {
			if (last_selected !=null)
				last_selected.setBackgroundColor(Color.TRANSPARENT);

			last_selected = (TableRow)v;
			last_selected.setBackgroundColor(Color.GRAY);
			current_selection = last_selected;
		}
	}; 
	View.OnClickListener buttonListener = new View.OnClickListener() {
		
		@Override
		public void onClick(View v) {
			switch(v.getId())
			{
			case R.id.DrinkManClose:
				dismiss();
				break;
			case R.id.DrinkManDelete:
				if (current_selection != null)
				{
					Builder bld = new AlertDialog.Builder(getContext());
					bld.setMessage("Are you sure you want to delete the selected drink?");
					bld.setNegativeButton("Cancel", null);
					bld.setPositiveButton("OK", new OnClickListener() {
						
						@Override
						public void onClick(DialogInterface dialog, int which) {
							String[] args = { ""+current_selection.getId() };
							Alcometer.db.execSQL("DELETE FROM 'Drinks' WHERE id=?",args);
							updateView();							
						}
					});
					
					bld.show();
					
				}
				break;
			case R.id.DrinkManAdd:
					OnDismissListener dl = new OnDismissListener() {
						
						@Override
						public void onDismiss(DialogInterface dialog) {
							updateView();
						}
					};
					DrinkEditDialog ded = new DrinkEditDialog(getContext(), -1);
					ded.setOnDismissListener(dl);
					ded.show();
				break;
			case R.id.DrinkManEdit:
				if (current_selection != null)
				{
					OnDismissListener dledit = new OnDismissListener() {
						
						@Override
						public void onDismiss(DialogInterface dialog) {
							updateView();
						}
					};
					DrinkEditDialog ded1 = new DrinkEditDialog(getContext(), current_selection.getId());
					ded1.setOnDismissListener(dledit);
					ded1.show();
				}
				break;
				
			}
			
		}
	};
	
	public DrinkDialog(Context context) {
		super(context);
		setContentView(R.layout.drink_manager);
		findViewById(R.id.DrinkManClose).setOnClickListener(buttonListener);
		findViewById(R.id.DrinkManAdd).setOnClickListener(buttonListener);
		findViewById(R.id.DrinkManEdit).setOnClickListener(buttonListener);
		findViewById(R.id.DrinkManDelete).setOnClickListener(buttonListener);
		updateView();
	}
	
	
	private void updateView()
	{
		Context context = getContext();
		TableLayout tl = (TableLayout)findViewById(R.id.DrinkManTable);
		tl.removeAllViews();
		Cursor cur = Alcometer.db.rawQuery("SELECT id, picture_id, drink, volume, precentage FROM Drinks", null);
		
		while(cur.moveToNext()){
			TableRow tr = new TableRow(context);
			tr.setGravity(Gravity.CENTER_VERTICAL);

			ImageView iv = new ImageView(context);
			iv.setImageResource(Alcometer.picture_ids[cur.getInt(1)%Alcometer.picture_ids.length]);
			iv.setScaleType(ScaleType.FIT_CENTER);
			iv.setLayoutParams(new TableRow.LayoutParams(40, 40));

			TextView tv = new TextView(context);
			tv.setText(cur.getString(2));
			tv.setMaxWidth(100);
			
			TextView tv1 = new TextView(context);
			tv1.setText(cur.getString(3)+"L");
			
			TextView tv2 = new TextView(context);
			tv2.setText(cur.getString(4));
			
			tr.setOnClickListener(rowListener);

			tr.addView(iv);
			tr.addView(tv);
			tr.addView(tv1);
			tr.addView(tv2);
			tr.setId(cur.getInt(0));
			tr.setClickable(true);
			tl.addView(tr);
		}
		
	
	}

}
