package alco.com;

import android.app.Dialog;
import android.content.Context;
import android.database.Cursor;
import android.database.DataSetObserver;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.SpinnerAdapter;
import android.widget.TextView;

public class DrinkEditDialog extends Dialog {

	private int id;
	
	private View.OnClickListener buttonListener = new View.OnClickListener() {
		
		@Override
		public void onClick(View v) {
			if (v.getId() == R.id.DrinkEditOK)
			{
				TextView name = (TextView)findViewById(R.id.DrinkEditName);
				TextView precentage = (TextView)findViewById(R.id.DrinkEditPrecentage);
				TextView volume = (TextView)findViewById(R.id.DrinkEditVolume);
				Spinner img = (Spinner)findViewById(R.id.DrinkEditImgSel);
				
				if (name.getText().length() == 0 || precentage.getText().length() == 0 || volume.getText().length() == 0)
				{
					
				}
				else
				{
					if (id == -1)
					{
						String[] args = { name.getText().toString(), precentage.getText().toString(), volume.getText().toString(), ""+img.getSelectedItemId() };
						Alcometer.db.execSQL("INSERT INTO 'Drinks' (drink,precentage,volume,picture_id)values(?,?,?,?)", args);
					}
					else
					{
						String[] args = { name.getText().toString(), precentage.getText().toString(), volume.getText().toString(), ""+img.getSelectedItemId(), ""+id };
						Alcometer.db.execSQL("UPDATE Drinks SET drink=?,precentage=?,volume=?,picture_id=? WHERE id = ?", args);
					}
					dismiss();
				}
			}
			else
			{
				cancel();
			}
		}
	};
	public DrinkEditDialog(Context context, int _id) {
		super(context);
		setContentView(R.layout.drink_edit);
		id = _id;
		
		EditText name = (EditText) findViewById(R.id.DrinkEditName);
		EditText precentage = (EditText)  findViewById(R.id.DrinkEditPrecentage);
		EditText volume = (EditText) findViewById(R.id.DrinkEditVolume);
		Spinner s = (Spinner)findViewById(R.id.DrinkEditImgSel);

		name.setText("");
		precentage.setText(""+0.0);
		volume.setText(""+0.0);
		
		//SPINNER ADAPTER STARTS
		SpinnerAdapter sa = new SpinnerAdapter() {
			
			@Override
			public void unregisterDataSetObserver(DataSetObserver observer) {}
			
			@Override
			public void registerDataSetObserver(DataSetObserver observer) {}
			
			@Override
			public boolean isEmpty() { return false; }
			
			@Override
			public boolean hasStableIds() { return true; }
			
			@Override
			public int getViewTypeCount() {
				// TODO Auto-generated method stub
				return Alcometer.picture_ids.length;
			}
			
			@Override
			public View getView(int position, View convertView, ViewGroup parent) {
				ImageView iv = null;
				if (convertView != null)
				{
					iv = (ImageView)convertView;
				}
				else
				{
					iv = new ImageView(getContext());
				}
				
				iv.setImageResource(Alcometer.picture_ids[position]);
				return iv;
			}
			
			@Override
			public int getItemViewType(int position) { return 0; }
			
			@Override
			public long getItemId(int position) { return position; }
			
			@Override
			public Object getItem(int position) { return null; }
			
			@Override
			public int getCount() { return Alcometer.picture_ids.length; }
			
			@Override
			public View getDropDownView(int position, View convertView, ViewGroup parent) {
				ImageView iv = null;
				if (convertView != null)
				{
					iv = (ImageView)convertView;
				}
				else
				{
					iv = new ImageView(getContext());
				}
				
				iv.setImageResource(Alcometer.picture_ids[position]);
				return iv;
			}
		};
		//SPINNER ADAPTER ENDS
		
		s.setAdapter(sa);
		
		if (_id != -1)
		{
			String[] args = { ""+_id };
			Cursor cur = Alcometer.db.rawQuery("SELECT precentage, drink, volume, picture_id FROM 'Drinks' WHERE id = ?", args);

			if (cur.moveToNext())
			{
				name.setText(cur.getString(1));
				precentage.setText(""+cur.getFloat(0));
				volume.setText(""+cur.getFloat(2));
				Log.i("Alcometer", "DrinkEdit"+cur.getInt(3));
				s.setSelection(cur.getInt(3)%Alcometer.picture_ids.length, true);
			}
			else
			{
				id = -1;
			}
		}

		findViewById(R.id.DrinkEditOK).setOnClickListener(buttonListener);
		findViewById(R.id.DrinkEditCancel).setOnClickListener(buttonListener);
	}
	
}
