package alco.com;

import java.util.Date;

import android.app.Dialog;
import android.content.Context;
import android.database.Cursor;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.ImageView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.ImageView.ScaleType;

public class DrinkLog extends Dialog {

	private TableRow current_selection = null;
	View.OnClickListener rowListener = new View.OnClickListener() {
		private TableRow last_selected = null;
		

		@Override
		public void onClick(View v) {
			if (last_selected !=null)
				last_selected.setBackgroundColor(Color.TRANSPARENT);

			last_selected = (TableRow)v;
			last_selected.setBackgroundColor(Color.GRAY);
			current_selection = last_selected;
		}
	}; 

	View.OnClickListener buttonListener = new View.OnClickListener() {
		
		@Override
		public void onClick(View v) {
			switch(v.getId())
			{
			case R.id.DrinkLogClose:
				dismiss();
				break;

			case R.id.DrinkLogRemoveDrink:
				if (current_selection != null)
				{
					String[] args = { ""+current_selection.getId() };
					Cursor cur = Alcometer.db.rawQuery("SELECT volume*precentage*7.894 as 'calc' FROM 'DrinkLog' WHERE id = ?", args);
					cur.moveToFirst();
					double calc = cur.getDouble(0);

					Alcometer.db.execSQL("DELETE FROM 'DrinkLog' WHERE id = ?", args);
					Log.i("Alcometer ", cur.getString(0));
					Alcometer.current_grams_of_alcohol -= calc;
					if (Alcometer.current_grams_of_alcohol < 0.0)
						Alcometer.current_grams_of_alcohol = 0.0;
					
					Alcometer.last_update_time = new Date();
					updateView();
				}
				break;

			case R.id.DrinkLogResetAll:
				Alcometer.db.execSQL("DELETE FROM 'DrinkLog'");
				Alcometer.current_grams_of_alcohol = 0.0;
				Alcometer.last_update_time = new Date();
				dismiss();
				break;
			}
			
		}
	};
	public DrinkLog(Context context) {
		super(context);
		setContentView(R.layout.drink_log);
		findViewById(R.id.DrinkLogClose).setOnClickListener(buttonListener);
		findViewById(R.id.DrinkLogResetAll).setOnClickListener(buttonListener);
		findViewById(R.id.DrinkLogRemoveDrink).setOnClickListener(buttonListener);
		updateView();
	}

	private void updateView()
	{
		Context context = getContext();
		TableLayout tl = (TableLayout)findViewById(R.id.DrinkLogTable);
		tl.removeAllViews();
		Cursor cur = Alcometer.db.rawQuery("SELECT id, picture_id, drink, volume, precentage FROM DrinkLog", null);
		
		while(cur.moveToNext()){
			TableRow tr = new TableRow(context);
			tr.setGravity(Gravity.CENTER_VERTICAL);

			ImageView iv = new ImageView(context);
			iv.setImageResource(Alcometer.picture_ids[cur.getInt(1)%Alcometer.picture_ids.length]);
			iv.setScaleType(ScaleType.FIT_CENTER);
			iv.setLayoutParams(new TableRow.LayoutParams(40, 40));

			TextView tv = new TextView(context);
			tv.setText(cur.getString(2));
			tv.setMaxWidth(100);
			
			TextView tv1 = new TextView(context);
			tv1.setText(cur.getString(3)+"L");
			
			TextView tv2 = new TextView(context);
			tv2.setText(cur.getString(4));
			
			tr.setOnClickListener(rowListener);

			tr.addView(iv);
			tr.addView(tv);
			tr.addView(tv1);
			tr.addView(tv2);
			tr.setId(cur.getInt(0));
			tr.setClickable(true);
			tl.addView(tr);
		}
		
	
	}
}
